#!/usr/bin/perl -w

# traf-lister.cgi - Perl/HTML/CGI front end to graphs 
#                   created by rtr-graph

use strict;
use CGI;

my $www_dir = '/www/html/traffic';
my $cgi_dir = '/cgi-bin2';
my $bin_dir = '/usr/local/bin';
my $url = 'http://10.62.1.105/traffic';

my $page = CGI::new();

my ($mday, $mon, $year) = (localtime(time))[3,4,5];
my $today = sprintf("%4d%2.2d%2.2d", $year += 1900, $mon += 1, $mday);

my @data = $page->param;

print $page->header(-type=>'text/html',
                    -expires=>'now');
print $page->start_html('Pick a Graph');

foreach (@data) {
   next if (!/^button/);
   foreach my $val ($page->param("$_")) {
      system("$bin_dir/rtr-graph --cfg $val.cfg --date today");
   }
}

opendir (DIR, "$www_dir");
my %list;
   foreach my $file (sort(readdir DIR)) {
      if ( $file =~ /\.jpg$/ ) {
         (my $pre = $file) =~ s/^(\w*)\..*/$1/;
         unshift(@{$list{$pre}}, $file);
      }
   }
closedir DIR;

print "<center>\n";
print $page->h1("Traffic Graphs for Network Devices");
print $page->h4("Select one or more Traffic Graphs to view");
print "To generate a new graph, select the button and press Submit\n";

print $page->startform(-method=>'POST',
                       -action=>"$cgi_dir/traf-lister.cgi",
                       -name=>'Form');

my @keys = keys(%list);
print "<table><tr>\n";
foreach (@keys) {
   unshift(@{$list{$_}}, 'No Graph');
   print "<td>\n";
   print "<INPUT TYPE=\"radio\" NAME=\"button_$_\" VALUE=\"$_\" ";
   print "UNCHECKED>Graph $_ <br>\n";
   print $page->scrolling_list(-name=>"list_$_",
                               -values=>\@{$list{$_}},
                               -size=>10,
                               -default=>'No Graph',
                               -multiple=>'true');
   print "</td>\n";
}

print "</tr></table><br>";
print $page->submit(-name=>'SUBMIT',
                    -value=>'Submit');
print $page->reset;

print "<br>";

foreach (@data) {
   next if (!/^list/);
   foreach my $graph ($page->param("$_")) {
      next if ($graph eq "No Graph");
      print "<img src=\"$url/$graph\"><br>";
   }
}
print "\n</center>";
print $page->end_html();

